/*!
 * scroll-watcher - v1.4.0
 * A lightweight, blazing fast, rAF based, scroll watcher.
 * https://github.com/jonataswalker/scroll-watcher
 * Built: Wed Jan 22 2020 15:21:34 GMT-0300 (Brasilia Standard Time)
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).ScrollWatcher=e()}(this,function(){"use strict";function t(){}t.prototype={on:function(t,e,n){var o=this.e||(this.e={});return(o[t]||(o[t]=[])).push({fn:e,ctx:n}),this},once:function(t,e,n){var o=this;function i(){o.off(t,i),e.apply(n,arguments)}return i._=e,this.on(t,i,n)},emit:function(t){for(var e=[].slice.call(arguments,1),n=((this.e||(this.e={}))[t]||[]).slice(),o=0,i=n.length;o<i;o++)n[o].fn.apply(n[o].ctx,e);return this},off:function(t,e){var n=this.e||(this.e={}),o=n[t],i=[];if(o&&e)for(var r=0,s=o.length;r<s;r++)o[r].fn!==e&&o[r].fn._!==e&&i.push(o[r]);return i.length?n[t]=i:delete n[t],this}};var e=t,n=t;function u(t,e){if(void 0===e&&(e="Assertion failed"),!t){if("undefined"!=typeof Error)throw new Error(e);throw e}}function o(t,e,n){void 0===e&&(e=window.document);var o,i=Array.prototype.slice,r=[];if(/^(#?[\w-]+|\.[\w-.]+)$/.test(t))switch(t[0]){case"#":r=[(o="#"===(o=t.substr(1))[0]?o.substr(1,o.length):o,document.getElementById(o))];break;case".":r=i.call(e.getElementsByClassName(t.substr(1).replace(/\./g," ")));break;default:r=i.call(e.getElementsByTagName(t))}else r=i.call(e.querySelectorAll(t));return n?r:r[0]}function c(t){var e,n;switch((n=t)===window&&n.document&&n.location?"window":n===document?"htmldocument":"string"==typeof n?"string":p(n)?"element":void 0){case"window":case"htmldocument":case"element":e=t;break;case"string":e=o("#"===t[0]||"."===t[0]?t:"#"+t);break;default:console.warn("Unknown type")}return e}function p(t){return"HTMLElement"in window?!!t&&t instanceof HTMLElement:!!t&&"object"==typeof t&&1===t.nodeType&&!!t.nodeName}function i(){return[window.pageXOffset||document.documentElement&&document.documentElement.scrollLeft||document.body.scrollLeft,window.pageYOffset||document.documentElement&&document.documentElement.scrollTop||document.body.scrollTop]}function r(){return{w:window.innerWidth||document.documentElement.clientWidth,h:window.innerHeight||document.documentElement.clientHeight}}function f(t){var e=t.getBoundingClientRect(),n=document.documentElement;return{left:e.left+window.pageXOffset-n.clientLeft,top:e.top+window.pageYOffset-n.clientTop,width:t.offsetWidth,height:t.offsetHeight}}e.TinyEmitter=n;var l="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};for(var s,a=(function(s){(function(){var t,e,n,o,i,r;"undefined"!=typeof performance&&null!==performance&&performance.now?s.exports=function(){return performance.now()}:"undefined"!=typeof process&&null!==process&&process.hrtime?(s.exports=function(){return(t()-i)/1e6},e=process.hrtime,o=(t=function(){var t;return 1e9*(t=e())[0]+t[1]})(),r=1e9*process.uptime(),i=o-r):n=Date.now?(s.exports=function(){return Date.now()-n},Date.now()):(s.exports=function(){return(new Date).getTime()-n},(new Date).getTime())}).call(l)}(s={exports:{}},s.exports),s.exports),w="undefined"==typeof window?l:window,d=["moz","webkit"],h="AnimationFrame",m=w["request"+h],y=w["cancel"+h]||w["cancelRequest"+h],g=0;!m&&g<d.length;g++)m=w[d[g]+"Request"+h],y=w[d[g]+"Cancel"+h]||w[d[g]+"CancelRequest"+h];if(!m||!y){var v=0,I=0,b=[];m=function(t){if(0===b.length){var e=a(),n=Math.max(0,1e3/60-(e-v));v=n+e,setTimeout(function(){for(var t=b.slice(0),e=b.length=0;e<t.length;e++)if(!t[e].cancelled)try{t[e].callback(v)}catch(t){setTimeout(function(){throw t},0)}},Math.round(n))}return b.push({handle:++I,callback:t,cancelled:!1}),I},y=function(t){for(var e=0;e<b.length;e++)b[e].handle===t&&(b[e].cancelled=!0)}}function V(t){return m.call(w,t)}V.cancel=function(){y.apply(w,arguments)},V.polyfill=function(t){(t=t||w).requestAnimationFrame=m,t.cancelAnimationFrame=y};function O(t){this.Base=t,this.lastXY=[],this.watching={},this.viewport=r(),this.loopBound=this.loop.bind(this),this.runLoop(),this.setListeners(),this.rafId=null}var F="page:load",E="scrolling",B="enter",L="enter:full",x="exit:partial",A="exit",T={top:0,bottom:0};function X(t){return{isInViewport:t.isInViewport,isFullyInViewport:t.isFullyInViewport,isAboveViewport:t.isAboveViewport,isBelowViewport:t.isBelowViewport,isPartialOut:t.isPartialOut,isFullyOut:t.isFullyOut}}return O.prototype.loop=function(){this.lastXY.join()!==i().join()&&this.handleItems(),this.runLoop()},O.prototype.handleItems=function(){var e=this,n=this.getScrollData();this.Base.emit(E,n),Object.keys(this.watching).forEach(function(t){n.target=e.watching[t].node,e.recalculate(e.watching[t]),e.fireEvents(e.watching[t],n)})},O.prototype.fireEvents=function(t,e){t.isInViewport&&!t.wasInViewport&&(t.wasInViewport=!0,t.wasFullyOut=!1,t.emitter.emit(B,e)),t.isPartialOut&&!t.wasPartialOut&&(t.wasPartialOut=!0,t.wasFullyInViewport=!1,t.emitter.emit(x,e)),t.isFullyOut&&!t.wasFullyOut&&(t.wasFullyOut=!0,t.wasInViewport=!1,t.wasFullyInViewport=!1,t.emitter.emit(A,e)),t.isFullyInViewport&&!t.wasFullyInViewport&&(t.wasFullyInViewport=!0,t.wasPartialOut=!1,t.wasFullyOut=!1,t.emitter.emit(L,e))},O.prototype.getScrollData=function(){var t=i(),e=t[1]>this.lastXY[1];return{scrollX:(this.lastXY=t)[0],scrollY:t[1],scrollingDown:e,scrollingUp:!e}},O.prototype.stopLoop=function(){V.cancel(this.rafId)},O.prototype.runLoop=function(){this.rafId=V(this.loopBound)},O.prototype.recalculate=function(t){var e=t.dimensions.top+t.offset.top,n=t.dimensions.top+t.offset.bottom+t.dimensions.height,o=this.lastXY[1],i=this.lastXY[1]+this.viewport.h;t.isAboveViewport=e<o,t.isBelowViewport=i<n,t.isInViewport=e<=i&&o<n,t.isFullyInViewport=o<=e&&n<=i||t.isAboveViewport&&t.isBelowViewport,t.isFullyOut=!t.isInViewport&&t.wasInViewport,t.isPartialOut=t.wasFullyInViewport&&!t.isFullyInViewport&&!t.isFullyOut},O.prototype.setListeners=function(){var n=this;document.addEventListener("readystatechange",function t(e){if("undefined"!=typeof document)switch(document.readyState){case"loading":case"interactive":break;case"complete":n.Base.emit(F,{scrollX:n.lastXY[0],scrollY:n.lastXY[1]}),document.removeEventListener("readystatechange",t)}},!1),window.addEventListener("resize",function(){n.viewport=r()},!1)},function(l){function a(){if(!(this instanceof a))return new a;l.call(this),this.counter=0,a.Internal=new O(this)}return l&&(a.__proto__=l),((a.prototype=Object.create(l&&l.prototype)).constructor=a).prototype.watch=function(t,e){var n;u("string"==typeof t||p(t),"@param `element` should be string type or DOM Element!"),u("number"==typeof e||"object"==typeof e||void 0===e,"@param `opt_offset` should be number or Object or undefined!");var o,i=++this.counter,r=new l,s=c(t);return u(p(s),"Couldn't evaluate ("+t+") to a valid DOM node"),n="number"==typeof e?{top:e,bottom:e}:function(t,e){var n={};for(var o in t)n[o]=t[o];for(var i in e)n[i]=e[i];return n}(T,e),a.Internal.watching[i]={node:s,emitter:r,offset:n,dimensions:f(s)},(o=a.Internal.watching[i]).isInViewport=!1,o.wasInViewport=!1,o.isAboveViewport=!1,o.wasAboveViewport=!1,o.isBelowViewport=!1,o.wasBelowViewport=!1,o.isPartialOut=!1,o.wasPartialOut=!1,o.isFullyOut=!1,o.wasFullyOut=!1,o.isFullyInViewport=!1,o.wasFullyInViewport=!1,{target:s,props:X(a.Internal.watching[i]),update:function(){var t,e=a.Internal.watching[i],n=a.Internal.getScrollData();return n.target=e.node,a.Internal.stopLoop(),(t=e).isInViewport=!1,t.isAboveViewport=!1,t.isBelowViewport=!1,t.isPartialOut=!1,t.isFullyOut=!1,t.isFullyInViewport=!1,e.dimensions=f(s),a.Internal.recalculate(e),this.props=X(e),a.Internal.fireEvents(e,n),a.Internal.runLoop(),this},once:function(t,e){return r.once(t,e,this),this},on:function(t,e){return r.on(t,e,this),this},off:function(t,e){return r.off(t,e,this),this}}},a.prototype.windowAtBottom=function(t){void 0===t&&(t=0);var e=a.Internal.lastXY[1],n=a.Internal.viewport.h;return t=parseInt(t,10),e+n>=Math.max(document.body.scrollHeight,document.documentElement.scrollHeight,document.body.offsetHeight,document.documentElement.offsetHeight,document.documentElement.clientHeight)-t},a.prototype.windowAtTop=function(t){return void 0===t&&(t=0),a.Internal.lastXY[1]<=(t=parseInt(t,10))},a}(e)});
